﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ComponentModel.DataAnnotations;
using System.Web.Mvc;

namespace Mvc3ValidationGroups.Sample.Models
{
    /// <summary>
    /// A contrived model to encapsulates the first step of placing an order where validation is split into different areas for functional and display purposes
    /// </summary>
    public class PlaceOrderInfo
    {
        [Required(AllowEmptyStrings = false)]
        [ValidationGroup("Critical")]
        public string ShoppingBasketKey { get; set; }

        [Required(AllowEmptyStrings = false)]
        [DataType(DataType.EmailAddress)]
        [ValidationGroup("AboutYou")]
        public string EmailAddress { get; set; }

        [Required(AllowEmptyStrings = false)]
        [DataType(DataType.Password)]
        [ValidationGroup("CreateAccount")]
        public string Password { get; set; }

        [Required(AllowEmptyStrings = false)]
        [DataType(DataType.Password)]
        [ValidationGroup("CreateAccount")]
        [Compare("Password")]
        public string ConfirmPassword { get; set; }

        [Required(AllowEmptyStrings = false)]
        [DataType(DataType.Text)]
        [ValidationGroup("AboutYou")]
        public string Name { get; set; }

        [Required(AllowEmptyStrings = false)]
        [ValidationGroup("DeliveryAddress")]
        public string DeliveryAddressLine1 { get; set; }

        [Required(AllowEmptyStrings = false)]
        [ValidationGroup("DeliveryAddress")]
        public string DeliveryAddressLine2 { get; set; }

        [Required(AllowEmptyStrings = false)]
        [ValidationGroup("DeliveryAddress")]
        public string DeliveryAddressPostalCode { get; set; }

        [Required(AllowEmptyStrings = false)]
        [ValidationGroup("InvoiceAddress")]
        public string InvoiceAddressLine1 { get; set; }

        [Required(AllowEmptyStrings = false)]
        [ValidationGroup("InvoiceAddress")]
        public string InvoiceAddressLine2 { get; set; }

        [Required(AllowEmptyStrings = false)]
        [ValidationGroup("InvoiceAddress")]
        public string InvoiceAddressPostalCode { get; set; }

    }
}